###################################################
### chunk number 1: 
###################################################
library(alphahull)
library(deldir)


###################################################
### chunk number 2: 
###################################################
# Uniform sample of size n=300 in the disc B(c,0.5)\B(c,0.25) 
# with c=(0.5,0.5). 
n<-150
m<-0
data<-matrix(0,n,2)
while(m<n){
x<-runif(1)
y<-runif(1)
if(((x-0.5)^2+(y-0.5)^2<=(0.5)^2 )&((x-0.5)^2+(y-0.5)^2>=(0.25)^2)){
m<-m+1
data[m,]<-c(x,y)
}
}
x<-data
alpha<-0.1


###################################################
### chunk number 3: 
###################################################
par(mfrow=c(1,1))
print(plot(0,type="n",xlim=c(0,1),ylim=c(0,1),xlab="",ylab="",axes=F))
print(plot(ahull(x,alpha=alpha),col=c(6,1,1),xlab="",ylab="",add=T))


###################################################
### chunk number 4: 
###################################################
par(mfrow=c(1,1))
print(plot(0,type="n",xlim=c(0,1),ylim=c(0,1),xlab="",ylab="",axes=F))
print(plot(ashape(x,alpha=alpha),col=c(4,1),xlab="",ylab="",add=T))


###################################################
### chunk number 5: 
###################################################
# Uniform sample of size n=300 in the disc B(c,0.5)\B(c,0.25) 
# with c=(0.5,0.5). 
n<-300
m<-0
data<-matrix(0,n,2)
while(m<n){
x<-runif(1)
y<-runif(1)
if(((x-0.5)^2+(y-0.5)^2<=(0.5)^2 )&((x-0.5)^2+(y-0.5)^2>=(0.25)^2)){
m<-m+1
data[m,]<-c(x,y)
}
}
x<-data


###################################################
### chunk number 6: 
###################################################
par(mfrow=c(1,3))
alpha1=0.02
alpha2=0.25
alpha3=1
plot(ashape(x,alpha=alpha1),col=c(4,1),xlab="",ylab="",main=expression(paste(alpha," = 0.02 ")))
plot(ashape(x,alpha=alpha2),col=c(4,1),xlab="",ylab="",main=expression(paste(alpha," = 0.25")))
plot(ashape(x,alpha=alpha3),col=c(4,1),xlab="",ylab="",main=expression(paste(alpha," = 1")))
par(mfrow=c(1,1))


###################################################
### chunk number 7: 
###################################################
#x<-matrix(runif(20),nc=2)
x1<-c(0.5915,0.6230,0.9689,0.8248,0.9392,0.8156,0.2050,0.9757,0.0957,0.4139)
y1<-c(0.472,0.619,0.304,0.197,0.716,0.575,0.507,0.574,0.996,0.893)
x<-cbind(x1,y1)


###################################################
### chunk number 8: 
###################################################
par(mfrow=c(1,1))
print(plot(0,type="n",xlim=c(0,1),ylim=c(0,1),xlab="",ylab="",axes=F))
print(plot(delvor(x),col=1:3,xlab="",ylab="",add=T))


###################################################
### chunk number 9: 
###################################################
xdeldir<-c(0.7016204,0.8409771,0.1298654,0.6324295,0.9755833,0.9558375,0.3511134,0.9891238,0.4572095,0.545416)
ydeldir<-c(0.1698826,0.3654726,0.5892516,0.6108104,0.8855026,0.9910547,0.2433913,0.1406111,0.4103610,0.4450315)
xydeldir<-cbind(xdeldir,ydeldir)
delvor.obj<-delvor(xydeldir)


###################################################
### chunk number 10: 
###################################################
par(mfrow=c(1,2))
print(plot(deldir(xdeldir,ydeldir),col=c(2,3,1),xlab="",ylab="",xlim=c(-0.5,1.5),ylim=c(-0.5,1.5)))
print(plot(delvor(xydeldir),col=c(1,2,3,1,1,1),xlab="",ylab="",xlim=c(-0.5,1.5),ylim=c(-0.5,1.5),lwd=1))


###################################################
### chunk number 11: 
###################################################
xtri<-xdeldir
ytri<-ydeldir


###################################################
### chunk number 12: 
###################################################
par(mfrow=c(1,2))
print(plot(voronoi.mosaic(xtri,ytri),do.points=FALSE,main="",sub="",col=3,xlim=c(-0.5,1.5),ylim=c(-0.5,1.5)))
axis(1)
axis(2)
print(plot(tri.mesh(xtri,ytri),col=2,add=T))
points(xtri,ytri,col=1)
print(plot(delvor(xtri,ytri),col=c(1,2,3),xlim=c(-0.5,1.5),ylim=c(-0.5,1.5),xlab="",ylab=""))


###################################################
### chunk number 13: 
###################################################
x <- c(0.905, 0.606, 0.458, 0.988, 0.744)
y <- c(0.763, 0.937, 0.095, 0.259, 0.731) 
dv <- delvor(x,y)
dv


###################################################
### chunk number 14: 
###################################################
plot(dv, main = "Delaunay triangulation and Voronoi diagram",col = 1:3, xlab = "x-coordinate", ylab = "y-coordinate",xlim = c(-0.5, 1.5), ylim = c(-0.5, 1.5), number = TRUE)


###################################################
### chunk number 15: 
###################################################
par(mfrow=c(1,1))
print(plot(dv, main = "Delaunay triangulation and Voronoi diagram",col = 1:3, xlab = "x-coordinate", ylab = "y-coordinate",xlim = c(-0.5, 1.5), ylim = c(-0.5, 1.5), number = TRUE))


###################################################
### chunk number 16: 
###################################################
x<-matrix(runif(40),ncol=2)
alpha <- 0.2
alphashape <- ashape(x, alpha = alpha)


###################################################
### chunk number 17: 
###################################################
names(alphashape)
alphashape$alpha.extremes
alphashape$edges[, 1:2]
alphashape$length


###################################################
### chunk number 18: 
###################################################
plot(alphashape, col = c(4, 1), xlab = "x-coordinate", ylab = "y-coordinate",number= TRUE, main = expression(paste(alpha, "-shape")))


###################################################
### chunk number 19: 
###################################################
par(mfrow=c(1,1))
print(plot(alphashape, col = c(4, 1), xlab = "x-coordinate", ylab = "y-coordinate",number= TRUE, main = expression(paste(alpha, "-shape"))))


###################################################
### chunk number 20: 
###################################################
plot(alphashape, wlines = "del", col = c(4, 1, 2), xlab = "x-coordinate", ylab = "y-coordinate")


###################################################
### chunk number 21: 
###################################################
par(mfrow=c(1,1))
print(plot(alphashape, wlines = "del", col = c(4, 1, 2), xlab = "x-coordinate",ylab = "y-coordinate",main = expression(paste(alpha, "-shape and Delaunay triangulation"))))


###################################################
### chunk number 22: 
###################################################
par(mfrow=c(1,1))
plot(0,type="n",axes=FALSE,xlim=c(0,0.5),ylim=c(0,0.5),xlab="",ylab="")
r<-0.5
t<-0
segments(0,0,r*cos(t),r*sin(t),col=4,lty=2)
points(r*cos(t),r*sin(t),pch=19,col=4)

t<-pi/6
arrows(0,0,0.3*cos(t),0.3*sin(t))
v<-c(0.3*cos(t),0.3*sin(t))
v<-v/sqrt(sum(v^2))
arc(c(0,0),0.5,v,pi/6,col=4,lwd=2)
t<-pi/3
segments(0,0,r*cos(t),r*sin(t),col=4,lty=2)
points(r*cos(t),r*sin(t),pch=19,col=4)

t<-pi/12
v<-c(0.3*cos(t),0.3*sin(t))
v<-v/sqrt(sum(v^2))
arc(c(0,0),0.3,v,pi/12,col=1)


text(0.15,0.11,expression(italic(v)),cex=1.5)
text(0.31,0.07,expression(italic(theta)),cex=1.5)
text(-0.015,0,expression(italic(c)),cex=1.5)
text(0.15,0.3,expression(italic(r)),cex=1.5)


###################################################
### chunk number 23: 
###################################################
n <- 200
theta<-runif(n,0,2*pi)
r<-sqrt(runif(n,0.25^2,0.5^2))
x<-cbind(0.5+r*cos(theta),0.5+r*sin(theta))
alpha <- 0.15
alphahull <- ahull(x, alpha = alpha)


###################################################
### chunk number 24: 
###################################################
names(alphahull)
alphahull$complement[1:5,1:3]
alphahull$arcs[1:5,]
alphahull$length


###################################################
### chunk number 25: 
###################################################
plot(alphahull, col = c(6, rep(1, 5)), xlab = "x-coordinate",ylab = "y-coordinate", main = expression(paste(alpha, "-hull")))


###################################################
### chunk number 26: 
###################################################
par(mfrow=c(1,1))
print(plot(alphahull,col=c(6,rep(1,5)), xlab = "x-coordinate",ylab = "y-coordinate", main = expression(paste(alpha, "-hull"))))


###################################################
### chunk number 27: 
###################################################
plot(alphahull, col = c(6, rep(1, 5)), xlab = "x-coordinate", ylab = "y-coordinate", main = expression(paste(alpha, "-hull")))
warcs<- which(alphahull$arcs[,3]>0)
for (i in warcs) {
arc(alphahull$arcs[i, 1:2], alphahull$arcs[i,3], c(0,1), pi, col = "gray", lty = 2)
}


###################################################
### chunk number 28: 
###################################################
plot(alphahull, do.shape = TRUE, col = c(6, 4, rep(1, 4)), xlab = "x-coordinate", ylab = "y-coordinate", main = expression(paste(alpha, "-hull and ",alpha, "-shape")))


###################################################
### chunk number 29: 
###################################################
par(mfrow=c(1,2))
print(plot(alphahull, col = c(6, rep(1, 5)), xlab = "x-coordinate", ylab = "y-coordinate", main = expression(paste(alpha, "-hull"))))
warcs<- which(alphahull$arcs[,3]>0)
for (i in warcs) {
arc(alphahull$arcs[i, 1:2], alphahull$arcs[i,3], c(0,1), 2 * pi, col = "gray", lty = 2)
}
print(plot(alphahull, do.shape = TRUE, col = c(6, 4, rep(1, 4)),xlab = "x-coordinate", ylab = "y-coordinate",main = expression(paste(alpha, "-hull and ",alpha, "-shape")))
)


###################################################
### chunk number 30: 
###################################################
inahull(alphahull,c(0.5,0.5))
inahull(alphahull,c(0.6,0.2))


###################################################
### chunk number 31: 
###################################################
areaahull(alphahull)


###################################################
### chunk number 32: 
###################################################
par(mfrow=c(2,2))
for (k in 1:4){
snow <- koch(side = 1, niter = k)
plot(snow[, 1], snow[, 2], type = "l", xlab = "", ylab = "",axes=F,asp=TRUE)
polygon(snow[, 1], snow[, 2] , col = 4)
}


###################################################
### chunk number 33: 
###################################################
par(mfrow=c(2,2))
for (i in 1:4){
snow <- koch(side = 1, niter = i)
plot(snow[, 1], snow[, 2], type = "l", xlab = "", ylab = "",axes=F,asp=TRUE)
polygon(snow[, 1], snow[, 2] , col = 4)
}


###################################################
### chunk number 34: 
###################################################
unifkoch <- rkoch(2000, side = 1, niter = 3)
alpha=0.05
alphahull <- ahull(unifkoch, alpha = alpha)


###################################################
### chunk number 35: 
###################################################
alphahull$length
alphahull$ashape$length


###################################################
### chunk number 36: 
###################################################
par(mfrow=c(1,2))
plot(alphahull$ashape, col = c(4, 1), xlab = "x-coordinate", ylab = "y-coordinate",main = expression(paste(alpha, "-shape")),asp=TRUE)
plot(alphahull, col = c(6, rep(1, 5)), xlab = "x-coordinate", ylab = "y-coordinate", main = expression(paste(alpha, "-hull")),asp=TRUE)


###################################################
### chunk number 37: 
###################################################
unifkoch <- rkoch(2000, side = 1, niter = 3)
alpha1=0.15
alphashape1 <- ashape(unifkoch, alpha = alpha1)
alpha2=0.05
alphashape2 <- ashape(alphashape1$delvor.obj, alpha = alpha2)
alpha3=0.02
alphashape3 <- ashape(alphashape1$delvor.obj, alpha = alpha3)

par(mfrow=c(1,3))
plot(alphashape1, col = c(4, 1), xlab = "", ylab = "",asp=TRUE)
plot(alphashape2, col = c(4, 1), xlab = "", ylab = "",asp=TRUE)
plot(alphashape3, col = c(4, 1), xlab = "", ylab = "",asp=TRUE)


